import { BlockMove, Sequence } from "alg";
import { Transformation, KPuzzleDefinition } from "./spec";
import { MoveExpander } from "./move-expander";
export declare function Combine(def: KPuzzleDefinition, t1: Transformation, t2: Transformation): Transformation;
export declare function Multiply(def: KPuzzleDefinition, t: Transformation, amount: number): Transformation;
export declare function IdentityTransformation(definition: KPuzzleDefinition): Transformation;
export declare function Invert(def: KPuzzleDefinition, t: Transformation): Transformation;
export declare function EquivalentTransformations(def: KPuzzleDefinition, t1: Transformation, t2: Transformation): boolean;
export declare function EquivalentStates(def: KPuzzleDefinition, t1: Transformation, t2: Transformation): boolean;
export declare function stateForBlockMove(def: KPuzzleDefinition, blockMove: BlockMove): Transformation;
export declare class KPuzzle {
    definition: KPuzzleDefinition;
    state: Transformation;
    constructor(definition: KPuzzleDefinition);
    serialize(): string;
    applyBlockMove(blockMove: BlockMove): void;
    applyAlg(a: Sequence): void;
    applyMove(moveName: string): this;
    getMoveExpander(create: boolean): MoveExpander | undefined;
    setFaceNames(faceNames: Array<string>): void;
    addGrip(grip1: string, grip2: string, nslices: number): void;
    expandSlices(rep: string, blockMove: BlockMove): Transformation | undefined;
    expandSlicesByName(mv: string): Transformation | undefined;
}
